=== debian/changelog ===
yade (2020.01a-10~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Anton Gladky <gladk@debian.org>  Mon, 02 Nov 2020 20:39:17 +0100

yade (2020.01a-10) unstable; urgency=medium

  * [a1c3cd6] Refresh patch
  * [5d67b56] Fix one more FTBFS due to QT5

 -- Anton Gladky <gladk@debian.org>  Sat, 18 Jul 2020 09:25:10 +0200

yade (2020.01a-9) unstable; urgency=medium

  * [9fc78a3] Fix FTBFS due to deprecated QT5 call. (Closes: #964617)
  * [0bfca14] Apply cme fix dpkg

 -- Anton Gladky <gladk@debian.org>  Fri, 17 Jul 2020 22:01:23 +0200

yade (2020.01a-8) unstable; urgency=medium

  * [3091434] Remove texlive-generic-extra from build-depends. (Closes: #961560)
  * [114d383] Set compat level 13
  * [30a1dcf] Install some files in usr/share/doc

 -- Anton Gladky <gladk@debian.org>  Fri, 05 Jun 2020 21:11:47 +0200

yade (2020.01a-7) unstable; urgency=medium

  * [b4691c0] Fix GCC-10 compilation. (Closes: #958006)
  * [5df87c6] Fix doc generation for newer sphinx. (Closes: #955097)

 -- Anton Gladky <gladk@debian.org>  Tue, 21 Apr 2020 22:51:53 +0200

yade (2020.01a-6) unstable; urgency=medium

  * [170aba5] Fix and enable parallel collision detection
  * [a84e451] Set Standards-Version to 4.5.0

 -- Anton Gladky <gladk@debian.org>  Sat, 22 Feb 2020 21:25:23 +0100

yade (2020.01a-5) unstable; urgency=medium

  [ Janek Kozicki ]
  * [454079e] Temporarily disable insertionSortParallel()

  [ Anton Gladky ]
  * [4f506b3] Disable parallel builds due to Ubuntu-sync-delays because of it

 -- Anton Gladky <gladk@debian.org>  Sat, 25 Jan 2020 21:44:04 +0100

yade (2020.01a-4) unstable; urgency=medium

  * [9152615] Do not build parallel on "all" arch

 -- Anton Gladky <gladk@debian.org>  Wed, 15 Jan 2020 20:47:32 +0100

yade (2020.01a-3) unstable; urgency=medium

  * [1e60d00] Do not run some unreliable tests

 -- Anton Gladky <gladk@debian.org>  Mon, 13 Jan 2020 20:31:58 +0100

yade (2020.01a-2) unstable; urgency=medium

  * Source-only upload

 -- Anton Gladky <gladk@debian.org>  Mon, 13 Jan 2020 18:56:50 +0100

yade (2020.01a-1) unstable; urgency=medium

  * [7c3c753] New upstream version 2020.01a
  * [38933f9] Refresh patches
  * [b50855d] Refer to common license file for BSD.
  * [ae4b2ee] Some more patches cleanup

 -- Anton Gladky <gladk@debian.org>  Sun, 12 Jan 2020 10:01:19 +0100

yade (2019.12~git~0~e74819ea-8) unstable; urgency=medium

  * [7267baf] Do not build parallely on s390x

 -- Anton Gladky <gladk@debian.org>  Thu, 02 Jan 2020 16:49:17 +0100

yade (2019.12~git~0~e74819ea-7) unstable; urgency=medium

  * [648d18f] Fix workaround due to broken ipython3
  * [1770cf4] Set upstream metadata fields: Bug-Submit, Repository.

 -- Anton Gladky <gladk@debian.org>  Wed, 01 Jan 2020 21:21:51 +0100

yade (2019.12~git~0~e74819ea-6) unstable; urgency=medium

  * [e6ab441] Rename python-yade -> python3-yade. (Closes: #946984)
  * [1eb721d] One more try to build yade in parallel mode

 -- Anton Gladky <gladk@debian.org>  Tue, 17 Dec 2019 22:17:21 +0100

yade (2019.12~git~0~e74819ea-5) unstable; urgency=medium

  * [e6ab441] Rename python-yade -> python3-yade
  * [1eb721d] One more try to build yade in parallel mode

 -- Anton Gladky <gladk@debian.org>  Tue, 17 Dec 2019 22:16:58 +0100

yade (2019.12~git~0~e74819ea-4) unstable; urgency=medium

  * [1b686b2] Add python3-future to depends
  * [09226e4] Sort dependencies

 -- Anton Gladky <gladk@debian.org>  Thu, 12 Dec 2019 16:37:13 +0100

yade (2019.12~git~0~e74819ea-3) unstable; urgency=medium

  * [771cc36] Revert "Build parallel"

 -- Anton Gladky <gladk@debian.org>  Wed, 11 Dec 2019 06:46:11 +0100

yade (2019.12~git~0~e74819ea-2) unstable; urgency=medium

  * [bcecc74] Build less debug symbols on i386 because of FTBFS
  * [653b86d] Disable checkPolyhedraCrush-test
  * [5f1d4e2] Ignore quilt dir
  * [a1d6205] Build parallel

 -- Anton Gladky <gladk@debian.org>  Tue, 10 Dec 2019 20:26:33 +0100

yade (2019.12~git~0~e74819ea-1) unstable; urgency=medium

  [ Anton Gladky ]
  * Upload into unstable

  [ Joachim Reichel ]
  * [45453b0] Fix FTFBS with CGAL 5.0. (Closes: #946223)

 -- Anton Gladky <gladk@debian.org>  Sun, 08 Dec 2019 22:21:16 +0100

yade (2019.12~git~0~e74819ea-1~exp5) experimental; urgency=medium

  * [0b1db7f] One more fix for i386

 -- Anton Gladky <gladk@debian.org>  Sat, 07 Dec 2019 23:58:57 +0100

yade (2019.12~git~0~e74819ea-1~exp4) experimental; urgency=medium

  * [39e6dac] Fix FTBFS on arm64
  * [59c3227] Disable parallel build

 -- Anton Gladky <gladk@debian.org>  Fri, 06 Dec 2019 08:51:16 +0100

yade (2019.12~git~0~e74819ea-1~exp3) experimental; urgency=medium

  * [41716f6] Override dh_dwz

 -- Anton Gladky <gladk@debian.org>  Thu, 05 Dec 2019 17:00:47 +0100

yade (2019.12~git~0~e74819ea-1~exp2) experimental; urgency=medium

  * [4b32d92] Disable checkJCFpm.py test
  * [7e67a2e] Remove dh_dwz override

 -- Anton Gladky <gladk@debian.org>  Thu, 05 Dec 2019 06:30:10 +0100

yade (2019.12~git~0~e74819ea-1~exp1) experimental; urgency=medium

  * [ee07f9d] Switch to python3. (Closes: #938859)
  * [e4c0fff] Refresh patch
  * [9db90d4] Set Stndards-Version to 4.4.1
  * [648e6a3] Trim trailing whitespace.
  * [f961d72] Set upstream metadata fields: Repository.
  * [21d9f4b] Use canonical URL in Vcs-Browser.
  * [b71d6cb] Remove obsolete fields Name from debian/upstream/metadata.
  * [dee59f9] Update upstream/metadata
  * [2c51dcb] Temporarly use python-yade for python3-bindings
  * [b196fd3] Some tweaks in the d/rules to make package buildable
  * [62fdca3] Use libsqlite3-dev instead of libsqlite-dev
  * [f434690] Set upstream metadata fields: Repository-Browse.
  * [6b86884] Add dh-exec to BD
  * [a539492] New upstream version 2019.12~git~0~e74819ea

 -- Anton Gladky <gladk@debian.org>  Wed, 04 Dec 2019 23:08:05 +0100
